package org.dromara.web.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.web.domain.PatientAccount;
import org.dromara.web.domain.bo.PatientAccountBo;
import org.dromara.web.domain.vo.PatientAccountVo;
import org.dromara.web.mapper.PatientAccountMapper;
import org.dromara.web.service.IPatientAccountService;
import org.springframework.stereotype.Service;


import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 患者账户信息Service业务层处理
 *
 * @author Lion Li
 * @date 2025-08-07
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class PatientAccountServiceImpl implements IPatientAccountService {

    private final PatientAccountMapper baseMapper;

    /**
     * 查询患者账户信息
     *
     * @param id 主键
     * @return 患者账户信息
     */
    @Override
    public PatientAccountVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询患者账户信息列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 患者账户信息分页列表
     */
    @Override
    public TableDataInfo<PatientAccountVo> queryPageList(PatientAccountBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<PatientAccount> lqw = buildQueryWrapper(bo);
        Page<PatientAccountVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的患者账户信息列表
     *
     * @param bo 查询条件
     * @return 患者账户信息列表
     */
    @Override
    public List<PatientAccountVo> queryList(PatientAccountBo bo) {
        LambdaQueryWrapper<PatientAccount> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<PatientAccount> buildQueryWrapper(PatientAccountBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<PatientAccount> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(PatientAccount::getId);
        lqw.eq(bo.getPatientId() != null, PatientAccount::getPatientId, bo.getPatientId());
        lqw.like(StringUtils.isNotBlank(bo.getPatientName()), PatientAccount::getPatientName, bo.getPatientName());
        lqw.eq(bo.getPatientCaseId() != null, PatientAccount::getPatientCaseId, bo.getPatientCaseId());
        lqw.eq(StringUtils.isNotBlank(bo.getIdCard()), PatientAccount::getIdCard, bo.getIdCard());
        lqw.eq(bo.getSex() != null, PatientAccount::getSex, bo.getSex());
        lqw.eq(StringUtils.isNotBlank(bo.getPhone()), PatientAccount::getPhone, bo.getPhone());
        lqw.eq(StringUtils.isNotBlank(bo.getSerialNo()), PatientAccount::getSerialNo, bo.getSerialNo());

        return lqw;
    }

    /**
     * 新增患者账户信息
     *
     * @param bo 患者账户信息
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(PatientAccountBo bo) {
        PatientAccount add = MapstructUtils.convert(bo, PatientAccount.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改患者账户信息
     *
     * @param bo 患者账户信息
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(PatientAccountBo bo) {
        PatientAccount update = MapstructUtils.convert(bo, PatientAccount.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(PatientAccount entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除患者账户信息信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
